#include <stdio.h>
#include <imsls.h>

int main()
{
  float *r, *table;
  int  nr, iseed1, iseed2, iseed7;
  int *itable;

  nr = 5;
  iseed1 = 123457;
  iseed2 = 123457;
  iseed7 = 123457;

  /* Begin first stream, iopt = 1 (by default) */
  imsls_random_seed_set (iseed1);
  r = imsls_f_random_uniform (nr, 0);
  iseed1 = imsls_random_seed_get ();
  imsls_f_write_matrix ("First stream output", 1, 5, r,
			IMSLS_NO_COL_LABELS,
			IMSLS_NO_ROW_LABELS, 0);
  printf("    Output seed\t%d\n\n", iseed1);
  free(r);

  /* Begin second stream, iopt = 2 */
  imsls_random_option (2);
  imsls_random_seed_set (iseed2);
  r = imsls_f_random_uniform (nr, 0);
  iseed2 = imsls_random_seed_get ();
  imsls_f_random_table_get (&table, 0);
  imsls_f_write_matrix ("Second stream output", 1, 5, r,
			IMSLS_NO_COL_LABELS,
			IMSLS_NO_ROW_LABELS, 0);
  printf("    Output seed\t%d\n\n", iseed2);
  free(r);

  /* Begin third stream, iopt = 7 */
  imsls_random_option (7);
  imsls_random_seed_set (iseed7);
  r = imsls_f_random_uniform (nr, 0);
  iseed7 = imsls_random_seed_get ();
  imsls_random_GFSR_table_get (&itable, 0);
  imsls_f_write_matrix ("Third stream output", 1, 5, r,
			IMSLS_NO_COL_LABELS,
			IMSLS_NO_ROW_LABELS, 0);
  printf("    Output seed\t%d\n\n", iseed7);
  free(r);

  /* Reinitialize seed and resume first stream */
  imsls_random_option (1);
  imsls_random_seed_set (iseed1);
  r = imsls_f_random_uniform (nr, 0);
  iseed1 = imsls_random_seed_get ();
  imsls_f_write_matrix ("First stream output", 1, 5, r,
			IMSLS_NO_COL_LABELS,
			IMSLS_NO_ROW_LABELS, 0);
  printf("    Output seed\t%d\n\n", iseed1);
  free(r);

  /* 
   * Reinitialize seed and table for shuffling and
   * resume second stream 
   */
  imsls_random_option (2);
  imsls_random_seed_set (iseed2);
  imsls_f_random_table_set (table);
  r = imsls_f_random_uniform (nr, 0);
  iseed2 = imsls_random_seed_get ();
  imsls_f_write_matrix ("Second stream output", 1, 5, r,
			IMSLS_NO_COL_LABELS,
			IMSLS_NO_ROW_LABELS, 0);
  printf("    Output seed\t%d\n\n", iseed2);
  free(r);

  /* 
   * Reinitialize seed and table for GFSR and 
   * resume third stream.
   */
  imsls_random_option (7);
  imsls_random_seed_set (iseed7);
  imsls_random_GFSR_table_set (itable);
  r = imsls_f_random_uniform (nr, 0);
  iseed7 = imsls_random_seed_get ();
  imsls_f_write_matrix ("Third stream output", 1, 5, r,
			IMSLS_NO_COL_LABELS,
			IMSLS_NO_ROW_LABELS, 0);
  printf("    Output seed\t%d\n\n", iseed7);
  free(r);

}
